package com.gmail.romanesco2090.role;

import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Judge;
import org.aiwolf.common.data.Role;

import com.gmail.romanesco2090.TalkFactory;
import com.gmail.romanesco2090.base.BaseRole;
import com.gmail.romanesco2090.data.GameResult;
import com.gmail.romanesco2090.util.RandomSelect;

public class Medium extends BaseRole {

	public Medium(GameResult gameResult) {
		super(gameResult);
	}

	@Override
	public void dayStartAction15() {
		if(gameInfo.getDay() == 2 && turn == 0) {
			myTalkQue.offer(TalkFactory.comingoutRemark(gameInfo.getAgent(), Role.MEDIUM));
		}
		Judge identified = gameInfo.getMediumResult();
		if(identified != null) {
			myTalkQue.offer(TalkFactory.identRemark(identified.getTarget(), identified.getResult()));
		}
	}

	@Override
	public void talkAction15() {
		if (turn == 3 || turn == 5 || turn == 7) {
			votingCandidate = decideCnaditate(calculateVotedScore(talkMap, voteCountMap));
			votingTarget = RandomSelect.getOP(gameResult.winMap, votingCandidate);
			myTalkQue.offer(TalkFactory.voteRemark(votingTarget));
		}
	}

	@Override
	public Agent voteAction15() {
		if (votingTarget != null) {
			return votingTarget;
		} else if (!votingCandidate.isEmpty()) {
			return RandomSelect.getOP(gameResult.getWinMap(), votingCandidate);
		} else {
			return RandomSelect.getOP(gameResult.getWinMap(), getAliveOthersList());
		}
	}

}
