package com.gmail.romanesco2090.player;

import com.gmail.romanesco2090.data.GameResult;
import com.gmail.romanesco2090.role.Bodyguard;
import com.gmail.romanesco2090.role.Medium;
import com.gmail.romanesco2090.role.Possessed;
import com.gmail.romanesco2090.role.Seer;
import com.gmail.romanesco2090.role.Villager;
import com.gmail.romanesco2090.role.Werewolf;

public class RomanescoPlayer extends AbstractRoleAssignPlayer {

	public RomanescoPlayer() {

		GameResult gameResult = new GameResult();

		//狩人適用
		this.setBodyguardPlayer(new Bodyguard(gameResult));
		//霊媒師適用
		this.setMediumPlayer(new Medium(gameResult));
		//狂人適用
		this.setPossessedPlayer(new Possessed(gameResult));
		//占い師適用
		this.setSeerPlayer(new Seer(gameResult));
		//村人適用
		this.setVillagerPlayer(new Villager(gameResult));
		//人狼適用
		this.setWerewolfPlayer(new Werewolf(gameResult));
	}

	@Override
	public String getName() {
		return "Romanesco";
	}

}
